> ## Documentation Index
> Fetch the complete documentation index at: https://docs.guile.app/llms.txt
> Use this file to discover all available pages before exploring further.

# Update barber settings

> Update booking, authorization, and notification settings for the authenticated
barber.
Unspecified fields keep their current values.



## OpenAPI

````yaml /api-reference/Barbers/openapi.yaml patch /barbers/{id}/settings
openapi: 3.0.0
info:
  title: Barbers
  version: 0.1.0
  contact:
    name: Guile Engineering
    url: https://www.guile.app
    email: engineering@guile.app
  license:
    name: MIT
    url: https://opensource.org/license/mit
  description: The Barbers API provides operations for barbers on the Guile platform.
servers:
  - url: https://api.guile.app
    variables: {}
  - url: https://guile.fly.dev
    variables: {}
security: []
tags:
  - name: Barbers
    description: Barber profiles, schedules, and settings
paths:
  /barbers/{id}/settings:
    patch:
      tags:
        - Barbers
      summary: Update barber settings
      description: >-
        Update booking, authorization, and notification settings for the
        authenticated

        barber.

        Unspecified fields keep their current values.
      operationId: patchBarberSettings
      parameters:
        - name: id
          in: path
          required: true
          schema:
            $ref: '#/components/schemas/resourceId'
      requestBody:
        required: true
        content:
          application/merge-patch+json:
            schema:
              $ref: '#/components/schemas/barberSettingsPatch'
      responses:
        '200':
          description: |-
            Ok.
            The operation succeeded.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/barberSettings'
        '400':
          description: >-
            Bad Request.

            The request body, request headers, and/or query parameters are not
            well-formed.



            This problem response may have one of the following `type` values:

            *
            [https://docs.guile.app/problems/badRequest](https://docs.guile.app/problems/badRequest)
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/apiProblem'
        '401':
          description: >-
            Unauthorized.

            The operation requires authentication but no authentication or
            insufficient authentication was given.



            This problem response may have one of the following `type` values:

            *
            [https://docs.guile.app/problems/unauthorized](https://docs.guile.app/problems/unauthorized)
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/apiProblem'
        '403':
          description: >-
            Forbidden.

            The authenticated caller is not authorized to perform the requested
            operation.



            This problem response may have one of the following `type` values:

            *
            [https://docs.guile.app/problems/forbidden](https://docs.guile.app/problems/forbidden)
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/apiProblem'
        '404':
          description: >-
            Not Found.

            There is no such resource at the request URL.



            This problem response may have one of the following `type` values:

            *
            [https://docs.guile.app/problems/notFound](https://docs.guile.app/problems/notFound)
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/apiProblem'
        '422':
          description: >-
            Unprocessable Entity.

            The request body and/or query parameters were well-formed but
            otherwise invalid.



            This problem response may have one of the following `type` values:

            *
            [https://docs.guile.app/problems/unprocessableEntity](https://docs.guile.app/problems/unprocessableEntity)
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/apiProblem'
        '429':
          description: >-
            Too Many Requests.

            The client has sent too many requests in a given amount of time.



            This problem response may have one of the following `type` values:

            *
            [https://docs.guile.app/problems/tooManyRequests](https://docs.guile.app/problems/tooManyRequests)
          headers:
            Retry-After:
              required: true
              description: The number of seconds to wait before retrying the request.
              schema:
                type: integer
                format: uint32
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/apiProblem'
      security:
        - BearerAuth: []
components:
  schemas:
    resourceId:
      type: string
      description: >-
        The unique, opaque system identifier for a resource.

        This case-sensitive ID is also used as path parameters in URLs or in
        other

        properties or parameters that reference a resource by ID rather than
        URL.
    barberSettingsPatch:
      type: object
      properties:
        bookingInterval:
          allOf:
            - $ref: '#/components/schemas/bookingInterval'
          nullable: true
          description: Appointment booking time interval.
        offHours:
          type: object
          allOf:
            - $ref: '#/components/schemas/OffHoursSettingsMergePatchUpdateOrCreate'
          nullable: true
          description: Off-hours booking configuration.
      description: |-
        Representation used to patch barber settings using the
        [JSON Merge Patch](https://datatracker.ietf.org/doc/html/rfc7396)
        format and processing rules.
    barberSettings:
      type: object
      required:
        - bookingInterval
      properties:
        bookingInterval:
          allOf:
            - $ref: '#/components/schemas/bookingInterval'
          description: Appointment booking time interval.
        offHours:
          allOf:
            - $ref: '#/components/schemas/OffHoursSettings'
          description: Off-hours booking configuration.
      description: Barber settings.
    apiProblem:
      type: object
      required:
        - type
        - title
        - occurredAt
        - id
        - status
      properties:
        type:
          allOf:
            - $ref: '#/components/schemas/uri'
          description: A URI reference that identifies the problem type.
        title:
          type: string
          maxLength: 120
          description: >-
            A short, human-readable summary of the problem type. The title is
            usually the same for all

            problems with the same `type`.
        occurredAt:
          type: string
          format: date-time
          description: >-
            The date-time when this problem occurred, in [RFC
            3339](https://tools.ietf.org/html/rfc3339)

            date-time `YYYY-MM-DDThh:mm:ss.sssZ` format, UTC. This is derived
            and immutable.
        detail:
          type: string
          maxLength: 256
          description: >-
            A human-readable explanation specific to this occurrence of the
            problem.
        id:
          allOf:
            - $ref: '#/components/schemas/resourceId'
          description: >-
            The unique identifier for this problem. This is an immutable opaque
            string.
        status:
          allOf:
            - $ref: '#/components/schemas/statusCode'
          description: >-
            The [HTTP status
            code](https://datatracker.ietf.org/doc/html/rfc7231#section-6)for
            this

            occurrence of the problem.
        instance:
          allOf:
            - $ref: '#/components/schemas/uri'
          maxLength: 2048
          description: >-
            A URI reference that identifies the specific occurrence of the
            problem. This is the URI of an

            API resource that the problem is related to, with a unique error
            correlation ID URI fragment.
        attributes:
          type: object
          additionalProperties: {}
          description: >-
            Additional optional attributes related to the problem. This data
            conforms to the schema

            associated with the error type.
        recovery:
          allOf:
            - $ref: '#/components/schemas/clientFailureRecovery'
          description: The recovery contract for this problem occurrence.
        problems:
          type: array
          items:
            $ref: '#/components/schemas/problem'
          maxItems: 128
          description: |-
            Optional root-causes if there are multiple problems in the request
            or API call processing.
      description: >-
        API problem or error response, as per

        [RFC 9457
        application/problem+json](https://tools.ietf.org/html/rfc9457).
    bookingInterval:
      type: string
      enum:
        - '15'
        - '20'
        - '30'
        - '60'
      description: Appointment booking time intervals.
    OffHoursSettingsMergePatchUpdateOrCreate:
      type: object
      properties:
        schedule:
          allOf:
            - $ref: '#/components/schemas/OffHoursScheduleMergePatchUpdateOrCreate'
          description: Per-day off-hours time configuration.
        fee:
          type: string
          allOf:
            - $ref: '#/components/schemas/money'
          nullable: true
          description: |-
            Flat fee applied to off-hours appointments.
            If omitted, no additional fee is charged for off-hours bookings.
        requiresApproval:
          type: boolean
          nullable: true
          description: >-
            Whether off-hours booking requests require manual approval.

            When true, off-hours appointments must be approved by the barber
            before being confirmed.
      description: Off-hours booking configuration.
    OffHoursSettings:
      type: object
      required:
        - schedule
        - requiresApproval
      properties:
        schedule:
          allOf:
            - $ref: '#/components/schemas/OffHoursSchedule'
          description: Per-day off-hours time configuration.
        fee:
          allOf:
            - $ref: '#/components/schemas/money'
          description: |-
            Flat fee applied to off-hours appointments.
            If omitted, no additional fee is charged for off-hours bookings.
        requiresApproval:
          type: boolean
          description: >-
            Whether off-hours booking requests require manual approval.

            When true, off-hours appointments must be approved by the barber
            before being confirmed.
          default: true
      description: Off-hours booking configuration.
    uri:
      type: string
      maxLength: 1024
      format: uri
      description: A URI reference to an internal or external resource.
    statusCode:
      type: integer
      format: uint16
      minimum: 100
      maximum: 599
      description: The HTTP status code for a response.
    clientFailureRecovery:
      type: object
      required:
        - outcome
        - retry
      properties:
        outcome:
          allOf:
            - $ref: '#/components/schemas/clientFailureOutcome'
          description: The known outcome of the request.
        retry:
          allOf:
            - $ref: '#/components/schemas/clientRetryDirective'
          description: The safe retry action for the request.
        sessionAction:
          allOf:
            - $ref: '#/components/schemas/clientSessionAction'
          description: The session action required before the request can continue.
        rateLimit:
          allOf:
            - $ref: '#/components/schemas/rateLimit'
          description: The rate limit state that prevented the request.
      description: The recovery contract for a failed client request.
    problem:
      type: object
      required:
        - type
        - title
        - occurredAt
        - id
        - status
      properties:
        type:
          allOf:
            - $ref: '#/components/schemas/uri'
          description: A URI reference that identifies the problem type.
        title:
          type: string
          maxLength: 120
          description: >-
            A short, human-readable summary of the problem type. The title is
            usually the same for all

            problems with the same `type`.
        occurredAt:
          type: string
          format: date-time
          description: >-
            The date-time when this problem occurred, in [RFC
            3339](https://tools.ietf.org/html/rfc3339)

            date-time `YYYY-MM-DDThh:mm:ss.sssZ` format, UTC. This is derived
            and immutable.
        detail:
          type: string
          maxLength: 256
          description: >-
            A human-readable explanation specific to this occurrence of the
            problem.
        id:
          allOf:
            - $ref: '#/components/schemas/resourceId'
          description: >-
            The unique identifier for this problem. This is an immutable opaque
            string.
        status:
          allOf:
            - $ref: '#/components/schemas/statusCode'
          description: >-
            The [HTTP status
            code](https://datatracker.ietf.org/doc/html/rfc7231#section-6)for
            this

            occurrence of the problem.
        instance:
          allOf:
            - $ref: '#/components/schemas/uri'
          maxLength: 2048
          description: >-
            A URI reference that identifies the specific occurrence of the
            problem. This is the URI of an

            API resource that the problem is related to, with a unique error
            correlation ID URI fragment.
        attributes:
          type: object
          additionalProperties: {}
          description: >-
            Additional optional attributes related to the problem. This data
            conforms to the schema

            associated with the error type.
      description: >-
        Standard problem or error response, as per

        [RFC 9457
        application/problem+json](https://tools.ietf.org/html/rfc9457).
    OffHoursScheduleMergePatchUpdateOrCreate:
      type: object
      properties:
        monday:
          type: object
          allOf:
            - $ref: >-
                #/components/schemas/OffHoursDayConfigurationMergePatchUpdateOrCreate
          nullable: true
          description: Off-hours configuration for Monday.
        tuesday:
          type: object
          allOf:
            - $ref: >-
                #/components/schemas/OffHoursDayConfigurationMergePatchUpdateOrCreate
          nullable: true
          description: Off-hours configuration for Tuesday.
        wednesday:
          type: object
          allOf:
            - $ref: >-
                #/components/schemas/OffHoursDayConfigurationMergePatchUpdateOrCreate
          nullable: true
          description: Off-hours configuration for Wednesday.
        thursday:
          type: object
          allOf:
            - $ref: >-
                #/components/schemas/OffHoursDayConfigurationMergePatchUpdateOrCreate
          nullable: true
          description: Off-hours configuration for Thursday.
        friday:
          type: object
          allOf:
            - $ref: >-
                #/components/schemas/OffHoursDayConfigurationMergePatchUpdateOrCreate
          nullable: true
          description: Off-hours configuration for Friday.
        saturday:
          type: object
          allOf:
            - $ref: >-
                #/components/schemas/OffHoursDayConfigurationMergePatchUpdateOrCreate
          nullable: true
          description: Off-hours configuration for Saturday.
        sunday:
          type: object
          allOf:
            - $ref: >-
                #/components/schemas/OffHoursDayConfigurationMergePatchUpdateOrCreate
          nullable: true
          description: Off-hours configuration for Sunday.
      description: Off-hours schedule configuration for each day of the week.
    money:
      type: string
      pattern: ^-?(0|[1-9][0-9]*)\.[0-9][0-9]$
      format: decimal
      description: >-
        A monetary amount in the lowest denomination for the given currency.

        The numeric value is represented as a string so that it can be exact
        with no

        loss of precision. Values may be positive or negative.
      example: '456.78'
    OffHoursSchedule:
      type: object
      properties:
        monday:
          allOf:
            - $ref: '#/components/schemas/OffHoursDayConfiguration'
          description: Off-hours configuration for Monday.
        tuesday:
          allOf:
            - $ref: '#/components/schemas/OffHoursDayConfiguration'
          description: Off-hours configuration for Tuesday.
        wednesday:
          allOf:
            - $ref: '#/components/schemas/OffHoursDayConfiguration'
          description: Off-hours configuration for Wednesday.
        thursday:
          allOf:
            - $ref: '#/components/schemas/OffHoursDayConfiguration'
          description: Off-hours configuration for Thursday.
        friday:
          allOf:
            - $ref: '#/components/schemas/OffHoursDayConfiguration'
          description: Off-hours configuration for Friday.
        saturday:
          allOf:
            - $ref: '#/components/schemas/OffHoursDayConfiguration'
          description: Off-hours configuration for Saturday.
        sunday:
          allOf:
            - $ref: '#/components/schemas/OffHoursDayConfiguration'
          description: Off-hours configuration for Sunday.
      description: Off-hours schedule configuration for each day of the week.
    clientFailureOutcome:
      type: string
      enum:
        - notApplied
        - unknown
      description: The known outcome of a failed client request.
    clientRetryDirective:
      type: string
      enum:
        - doNotRetry
        - retrySameRequest
        - retrySameRequestAfterDelay
      description: The safe retry action for a failed client request.
    clientSessionAction:
      type: string
      enum:
        - refresh
        - signIn
      description: The session action required before a failed request can continue.
    rateLimit:
      type: object
      required:
        - limit
        - remaining
        - resetsAt
      properties:
        limit:
          type: integer
          format: uint64
          description: The maximum number of requests allowed in the active window.
        remaining:
          type: integer
          format: uint64
          description: The number of requests remaining in the active window.
        resetsAt:
          type: string
          format: date-time
          description: >-
            The date-time when the active window resets, in [RFC
            3339](https://tools.ietf.org/html/rfc3339) date-time
            `YYYY-MM-DDThh:mm:ss.sssZ` format, UTC.
      description: The rate limit state for the request.
    OffHoursDayConfigurationMergePatchUpdateOrCreate:
      type: object
      properties:
        earliestStartTime:
          type: string
          format: time
          nullable: true
          description: >-
            The earliest time bookings can be accepted before regular opening
            hours,

            in [RFC 3339](https://tools.ietf.org/html/rfc3339) time format
            (HH:MM).

            If omitted, no off-hours bookings are accepted before opening.
        latestEndTime:
          type: string
          format: time
          nullable: true
          description: >-
            The latest time bookings can be accepted after regular closing
            hours,

            in [RFC 3339](https://tools.ietf.org/html/rfc3339) time format
            (HH:MM).

            If omitted, no off-hours bookings are accepted after closing.
      description: Off-hours time configuration for a single day.
    OffHoursDayConfiguration:
      type: object
      properties:
        earliestStartTime:
          type: string
          format: time
          description: >-
            The earliest time bookings can be accepted before regular opening
            hours,

            in [RFC 3339](https://tools.ietf.org/html/rfc3339) time format
            (HH:MM).

            If omitted, no off-hours bookings are accepted before opening.
        latestEndTime:
          type: string
          format: time
          description: >-
            The latest time bookings can be accepted after regular closing
            hours,

            in [RFC 3339](https://tools.ietf.org/html/rfc3339) time format
            (HH:MM).

            If omitted, no off-hours bookings are accepted after closing.
      description: Off-hours time configuration for a single day.
  securitySchemes:
    BearerAuth:
      type: http
      scheme: Bearer

````